//funcion que tiene la responsabilidad de ordenar aleatoriamente un arreglo
function shuffle(a) {
   var array = a.slice(0);
   var currentIndex = array.length,
      temporaryValue, randomIndex;
   // While there remain elements to shuffle...
   while (0 !== currentIndex) {
      // Pick a remaining element...
      randomIndex = Math.floor(Math.random() * currentIndex);
      currentIndex -= 1;
      // And swap it with the current element.
      temporaryValue = array[currentIndex];
      array[currentIndex] = array[randomIndex];
      array[randomIndex] = temporaryValue;
   }
   return array;
}

$(document).ready(inicioREDI5);
//Propiedades
var indexPreguntaR1 = 0;
var indexProgresoR1 = 0;
var puntajeR1 = 0;
var cantidadPreguntas = 5;
var idTextoPreguntaR1 = "#preguntaTexto";
var idNumPreguntaR1 = "#preguntaNumero";
var idRespuestasR1 = "#respuestas";
var idEscenaR1 = "#escena";
var idBotonCalificarR1 = "#edModal__calificar";
var exitoR1 = false;
var mensajeR1 = "Inténtalo nuevamente.";
var idModal = ".modalCalificacion";
var botonCerrar = ".js-edModal__cerrar";

//Arreglo de preguntas
var arrayPreguntasInicialR1 = [{
   num: 1,
   pregunta: '¿En qué apoya el copasst?',
   respuestas: [{
         opcion: 'Minimizar y tratar los riesgos  de enfermedad; accidentes e incidentes laborales que se puedan presentar.',
         correcta: true
      },
      {
         opcion: 'Maximizar  e incluir los riesgos  de enfermedad; accidentes e incidentes laborales que no se puedan presentar.',
         correcta: false
      },
      {
         opcion: 'Seleccionar y contratar a los candidatos de safety y medical.',
         correcta: false
      },
      {
         opcion: 'Todas las anteriores.',
         correcta: false
      },
   ]
}, {
   num: 2,
   pregunta: 'El objetivo del Comité de convivencia, es:',
   respuestas: [{
         opcion: 'Crear y administrar un reglamento de mejores prácticas para ventas.',
         correcta: false
      },
      {
         opcion: 'Minimizar y tratar los riesgos  de enfermedad; accidentes e incidentes laborales que se puedan presentar.',
         correcta: false
      },
      {
         opcion: 'Contribuir a la protección de relaciones laborales armoniosas manteniendo las mejores condiciones y generando espacios de escucha oportuna y efectiva.',
         correcta: true
      },
      {
         opcion: 'Ninguna de las anteriores.',
         correcta: false
      },
   ]
}, {
   num: 3,
   pregunta: 'La prevención de riesgos laborales puede definirse como el conjunto de actividades y medidas que se llevan a cabo con el objetivo de evitar o disminuir las posibilidades de que nuestros colaboradores puedan sufrir algún tipo de daño derivado de su trabajo. Esta afirmación es:',
   respuestas: [{
         opcion: 'Verdadero',
         correcta: true
      },
      {
         opcion: 'Falso',
         correcta: false
      },
   ]
}, {
   num: 4,
   pregunta: 'Los tipos de riesgos que pueden existir en un lugar de trabajo son:',
   respuestas: [{
         opcion: 'Riesgos físicos, químicos y biológicos.',
         correcta: false
      },
      {
         opcion: 'Riesgos físicos, químicos, biológicos, psicosociales, de seguridad y ambiental.',
         correcta: true
      },
      {
         opcion: 'Riesgos psicosociales, de seguridad y ambiental.',
         correcta: false
      },
      {
         opcion: 'Ninguna de las anteriores.',
         correcta: false
      },
   ]
}, {
   num: 5,
   pregunta: 'Los elementos de protección personal son implementos y recomendaciones que ayudan a proteger o a minimizar la consecuencia de un accidente, incidente o enfermedad. Los elementos de protección personal se usan de acuerdo con el riesgo que se expone y se debe:',
   respuestas: [{
         opcion: 'Usar de manera adecuada.',
         correcta: false
      },
      {
         opcion: 'Brindar el mantenimiento.',
         correcta: false
      },
      {
         opcion: 'Reemplazar cuando se hayan detectado su caducidad.',
         correcta: false
      },
      {
         opcion: 'Seguir instrucciones.',
         correcta: false
      },
      {
         opcion: 'Todas las anteriores',
         correcta: true
      },
   ]
}, {
   num: 6,
   pregunta: 'Dräger es sinónimo de tecnología para la vida. El primer capítulo de esta historia se escribió en:',
   respuestas: [{
         opcion: '1989',
         correcta: false
      },
      {
         opcion: '1889',
         correcta: true
      },
      {
         opcion: '1887',
         correcta: false
      },
      {
         opcion: '1890',
         correcta: false
      },
   ]
}, {
   num: 7,
   pregunta: 'La ruta 2030 es el  Proyecto de transformación cultural que sirve además  como base para las acciones de comportamiento y manejo profesional que tengamos los colaboradores de la empresa.',
   respuestas: [{
         opcion: 'Verdadero',
         correcta: true
      },
      {
         opcion: 'Falso',
         correcta: false
      },
   ]
}, {
   num: 8,
   pregunta: 'Dräger es una empresa internacional en los campos de la tecnología médica y de la seguridad. Con nuestros productos y soluciones protegemos y salvamos la vida de personas en hospitales, cuerpos de bomberos, servicios de emergencias, agencias gubernamentales, minería e industria en todo el mundo. La siguiente afirmación es:',
   respuestas: [{
         opcion: 'Verdadero',
         correcta: true
      },
      {
         opcion: 'Falso',
         correcta: false
      },
   ]
}, {
   num: 9,
   pregunta: 'La seguridad de nuestros productos y sus usuarios es nuestra mayor prioridad. De la siguiente lista, selecciona las acciones que reflejan la calidad de los productos:',
   respuestas: [{
         opcion: 'Seguridad avanzada',
         correcta: false
      },
      {
         opcion: 'Calidad y gestión de riesgos',
         correcta: false
      },
      {
         opcion: 'Formación y concepto de servicio',
         correcta: false
      },
      {
         opcion: 'Todas las anteriores',
         correcta: true
      },
      {
         opcion: 'Ninguna de las anteriores',
         correcta: false
      },
   ]
}];
//Arreglo de preguntas desordenadas
var arrayPreguntasR1 = shuffle(arrayPreguntasInicialR1);

//Métodos
//funcion que tiene la responsabilidad de iniciar la actividad
function inicioREDI5() {
   arrayPreguntasR1 = arrayPreguntasR1.slice(-1 * cantidadPreguntas);
   //evento de calificar
   $(idBotonCalificarR1).click(calificarPregunta);
   //Cargo la pregunta inicial 
   mostrarPregunta();
   $(botonCerrar).on("click", reInit);

   $('.js-redi__btnCerrar').off('click');
   $('.js-redi__btnCerrar').on('click', cerrarRedi);

}

//función que tiene la responsabilida de mostrar la pregunta actual, depende del indexPreguntaR1
function mostrarPregunta() {
   var html_respuestas = '';
   var texto_pregunta = arrayPreguntasR1[indexPreguntaR1].pregunta;
   $(idNumPreguntaR1).html(indexPreguntaR1 + 1);
   $(idTextoPreguntaR1).html(texto_pregunta);
   var respuestas = shuffle(arrayPreguntasR1[indexPreguntaR1].respuestas);
   respuestas.forEach(function (respuesta, index) {
      // se construyo el html de los radio botones
      html_respuestas += '<div class="radio">\
                   <input type="radio" name="respuesta" id="respuesta' + index + '" data-correcto="' + respuesta.correcta + '" value="' + index + '">\
                   <label for="respuesta' + index + '">' + respuesta.opcion + '</label>\
              </div>';
   });
   $(idRespuestasR1).html(html_respuestas);
   $(idBotonCalificarR1).attr('disabled', true);
   $(idBotonCalificarR1).off('click');
   $(idBotonCalificarR1).text('Siguiente');
   $('[name=respuesta]').click(function () {
      $(idBotonCalificarR1).attr('disabled', false);
      $(idBotonCalificarR1).off('click');
      $(idBotonCalificarR1).on('click', calificarPregunta);
   });
   //Si es la ultima
   if (indexPreguntaR1 == arrayPreguntasR1.length - 1) {
      $(idBotonCalificarR1).off('click');
      $(idBotonCalificarR1).text('Calificar');
      $(idBotonCalificarR1).on('click', calificarPregunta);
   }
}

//funcion que tiene la responsabilidad de reiniciar el REDI5
function reInitR1() {

   setTimeout(function () {
      //$(idEscenaR1).removeClass('posicion6 posicion5 posicion4 posicion3 posicion2');
   }, 5000);
   $(idEscenaR1).removeClass('posicion5 posicion4 posicion3 posicion2');
   indexPreguntaR1 = 0;
   indexProgresoR1 = 0;
   puntajeR1 = 0;
   arrayPreguntasR1 = shuffle(arrayPreguntasInicialR1);
   arrayPreguntasR1 = arrayPreguntasR1.slice(-1 * cantidadPreguntas);
   exitoR1 = false;
   mostrarPregunta();
   $(idNumPreguntaR1).show();
   $(idBotonCalificarR1).click(calificarPregunta);
}
//funcion que tiene la responsabilidad de mostrar el modal de calificacion
function mostrarModalCalificacion() {
   puntajeR1 = puntajeR1.toFixed();
   if (puntajeR1 == 100) {
      exitoR1 = true;
   }
   mostrarCalificacion(idModal, puntajeR1 + "%", exitoR1, reInitR1);
}
//funcion que tiene la responsabilidad de verificar si la respuesta es correcta
function calificarPregunta() {
   $(idBotonCalificarR1).off('click');
   //Scroll ancla escena
   var altoVentana = $(window).height();
   var posicionScroll = $(idEscenaR1).offset().top + $('.backdrop').scrollTop() - altoVentana / 4;
   $('html, body, .backdrop').animate({
      scrollTop: posicionScroll
   }, 500);
   //se calcula el incremento
   var incremento = parseInt(100 / arrayPreguntasR1.length);
   //si la respuesta es correcta
   $(idEscenaR1).removeClass('error');
   $(idEscenaR1).removeClass('good');
   if (indexProgresoR1 < arrayPreguntasR1.length) {
      if ($('[name=respuesta]:checked').attr('data-correcto') == 'true') {
         $(idBotonCalificarR1).attr('disabled', false);
         setTimeout(function () {
            $(idEscenaR1).addClass('good');
         }, 10);
         switch (parseInt(indexProgresoR1)) {
            case 0:
               $(idEscenaR1).addClass('posicion2');
               break;
            case 1:
               $(idEscenaR1).removeClass('posicion2');
               $(idEscenaR1).addClass('posicion3');
               break;
            case 2:
               $(idEscenaR1).removeClass('posicion3');
               $(idEscenaR1).addClass('posicion4');
               break;
            case 3:
               $(idEscenaR1).removeClass('posicion4');
               $(idEscenaR1).addClass('posicion5');
               break;
            case 4:
               $(idEscenaR1).removeClass('posicion5');
               $(idEscenaR1).addClass('posicion6');
               break;
            default:
               break;
         }
         puntajeR1 = puntajeR1 + incremento;
         indexProgresoR1++
      } else {
         // Cuando la respuesta es incorrecta
         setTimeout(function () {
            $(idEscenaR1).addClass('error');
            $(idBotonCalificarR1).on('click', calificarPregunta);
         }, 10);

      }
   } else {
      reInitR1();
      return 0;
   }
   //si era la última pregunta se muestra el modal de calificacion
   if (indexPreguntaR1 == arrayPreguntasR1.length - 1) {
      console.log('settimeout')
      //muestra el modal de calificacion
      setTimeout(function () {
         if ($(idEscenaR1).hasClass("error")) {
            console.log('error tiemout');
            setTimeout(function () {
               mostrarModalCalificacion();
               $(idBotonCalificarR1).on('click', calificarPregunta);
            }, 600);
         } else {
            console.log('ok tiemout');
            setTimeout(function () {
               mostrarModalCalificacion();
               $(idBotonCalificarR1).on('click', calificarPregunta);
            }, 2200);
         }
      }, 15);

   } else {
      //siguiente pregunta
      indexPreguntaR1 = indexPreguntaR1 + 1;
      //se muestra la siguiente pregunta
      mostrarPregunta();
   }
}